All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2014
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with Git. In case Git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
20 # version of vcsh; the master branch is supposed to be clean at all times
21 # so you can most likely just use it nonetheless
26 echo "$SELF: fatal: $1" >&2
30 # We need to run getops as soon as possible so we catch -d and other
31 # options that will modify our behaviour.
32 # Commands are handled at the end of this script.
33 while getopts "c:dv" flag; do
34 if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
39 elif [ x"$1" = x'-v' ]; then
41 echo "verbose mode on"
43 elif [ x"$1" = x'-c' ]; then
44 VCSH_OPTION_CONFIG=$OPTARG
50 # Source file even if it's in $PWD and does not have any slashes in it
58 # Read configuration and set defaults if anything's not set
59 [ -n "$VCSH_DEBUG" ] && set -vx
60 : ${XDG_CONFIG_HOME:="$HOME/.config"}
62 # Read configuration files if there are any
63 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
64 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
65 if [ -n "$VCSH_OPTION_CONFIG" ]; then
66 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
67 if [ -r "$VCSH_OPTION_CONFIG" ]; then
68 source_all "$VCSH_OPTION_CONFIG"
70 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
73 [ -n "$VCSH_DEBUG" ] && set -vx
76 : ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
77 : ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
78 : ${VCSH_BASE:="$HOME"}
79 : ${VCSH_GITIGNORE:=exact}
80 : ${VCSH_GITATTRIBUTES:=none}
81 : ${VCSH_WORKTREE:=absolute}
83 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
84 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
87 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
88 fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
93 echo "usage: $SELF <options> <command>
98 -v Enable verbose mode
102 [<repo>] Clone from an existing repository
103 commit Commit in all repositories
104 delete <repo> Delete an existing repository
105 enter <repo> Enter repository; spawn new instance of \$SHELL
106 help Display this help text
107 init <repo> Initialize a new repository
108 list List all repositories
109 list-tracked List all files tracked by vcsh
111 <repo> List files tracked by a repository
112 pull Pull from all vcsh remotes
113 push Push to vcsh remotes
115 <newname> Rename repository
117 <command> Use this repository
118 status [<repo>] Show statuses of all/one vcsh repositories
119 upgrade <repo> Upgrade repository to currently recommended settings
120 version Print version information
121 which <substring> Find substring in name of any tracked file
123 <repo> Write .gitignore.d/<repo> via git ls-files
125 <repo> <git command> Shortcut to run git commands directly
126 <repo> Shortcut to enter repository" >&2
130 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
134 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
138 echo "$SELF: error: $1" >&2
142 echo "$SELF: info: $1"
148 git remote add origin "$GIT_REMOTE"
149 git config branch.master.remote origin
150 git config branch.master.merge refs/heads/master
151 if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
152 info "remote is empty, not merging anything"
157 git ls-tree -r --name-only origin/master | (while read object; do
159 error "'$object' exists." &&
162 [ x"$VCSH_CONFLICT" = x'1' ]) &&
163 fatal "will stop after fetching and not try to merge!
164 Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
165 git merge origin/master
169 hook post-clone-retired
174 for VCSH_REPO_NAME in $(list); do
175 echo "$VCSH_REPO_NAME: "
176 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
178 git commit --untracked-files=no --quiet
179 VCSH_COMMAND_RETURN_CODE=$?
186 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
188 info "This operation WILL DESTROY DATA!"
189 files=$(git ls-files)
190 echo "These files will be deleted:
194 AGAIN, THIS WILL DELETE YOUR DATA!
195 To continue, type 'Yes, do as I say'"
197 [ "x$answer" = 'xYes, do as I say' ] || exit 16
198 for file in $files; do
199 rm -f $file || info "could not delete '$file', continuing with deletion"
201 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
212 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
216 for hook in "$VCSH_HOOK_D/$1"* "$VCSH_HOOK_D/$VCSH_REPO_NAME.$1"*; do
217 [ -x "$hook" ] || continue
218 verbose "executing '$hook'"
225 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
226 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
227 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
228 git init --shared=0600
234 for repo in "$VCSH_REPO_D"/*.git; do
235 [ -d "$repo" ] && [ -r "$repo" ] && echo "$(basename "$repo" .git)"
240 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
245 for VCSH_REPO_NAME in $(list); do
247 done | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
248 sed 's/[,\&]/\\&/g')," | sort -u
253 git ls-files | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
254 sed 's/[,\&]/\\&/g')," | sort -u
259 for VCSH_REPO_NAME in $(list); do
260 printf '%s: ' "$VCSH_REPO_NAME"
261 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
264 VCSH_COMMAND_RETURN_CODE=$?
272 for VCSH_REPO_NAME in $(list); do
273 printf '%s: ' "$VCSH_REPO_NAME"
274 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
277 VCSH_COMMAND_RETURN_CODE=$?
288 for VCSH_REPO_NAME in $(list); do
289 [ -n $ran_once ] && files_untracked=$(printf '%s\n' "$files_untracked" | grep -Fx "$files_other")
290 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
291 files_other="$(git ls-files --others)"
292 [ -z $ran_once ] && { ran_once=1; files_untracked=$files_other; }
294 echo "$files_untracked" | sort -u
299 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
300 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
302 # Now that the repository has been renamed, we need to fix up its configuration
303 # Overwrite old name..
305 VCSH_REPO_NAME=$VCSH_REPO_NAME_NEW
306 # ..and clobber all old configuration
314 VCSH_COMMAND_RETURN_CODE=$?
319 if [ -n "$VCSH_REPO_NAME" ]; then
320 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
322 git status --short --untracked-files='no'
323 VCSH_COMMAND_RETURN_CODE=$?
325 for VCSH_REPO_NAME in $(list); do
326 echo "$VCSH_REPO_NAME:"
327 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
329 git status --short --untracked-files='no'
330 VCSH_COMMAND_RETURN_CODE=$?
338 # fake-bare repositories are not bare, actually. Set this to false
339 # because otherwise Git complains "fatal: core.bare and core.worktree
341 git config core.bare false
342 # core.worktree may be absolute or relative to $GIT_DIR, depending on
344 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
345 git config core.worktree "$(cd "$GIT_DIR" && GIT_WORK_TREE=$VCSH_BASE git rev-parse --show-cdup)"
346 elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
347 git config core.worktree "$VCSH_BASE"
349 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
350 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
351 git config vcsh.vcsh 'true'
353 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
354 [ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
360 VCSH_DIRECTORY=$VCSH_REPO_NAME; export VCSH_DIRECTORY
364 for VCSH_REPO_NAME in $(list); do
365 for VCSH_FILE in $(get_files); do
366 echo "$VCSH_FILE" | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
372 # Don't do anything if the user does not want to write gitignore
373 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
374 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
379 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
382 gitignores=$(for file in $(git ls-files); do
384 echo "$file"; new=${file%/*}
385 [ x"$file" = x"$new" ] && break
390 # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
391 # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
392 # To make every OS happy, set full path explicitly
393 tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
395 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
396 for gitignore in $gitignores; do
397 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
398 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
399 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
403 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
404 rm -f "$tempfile" || error "could not delete '$tempfile'"
407 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
408 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
409 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
410 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
412 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
413 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
418 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
419 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
422 VCSH_COMMAND=$1; export VCSH_COMMAND
424 case $VCSH_COMMAND in
425 clon|clo|cl) VCSH_COMMAND=clone;;
426 commi|comm|com|co) VCSH_COMMAND=commit;;
427 delet|dele|del|de) VCSH_COMMAND=delete;;
428 ente|ent|en) VCSH_COMMAND=enter;;
429 hel|he) VCSH_COMMAND=help;;
430 ini|in) VCSH_COMMAND=init;;
431 pul) VCSH_COMMAND=pull;;
432 pus) VCSH_COMMAND=push;;
433 renam|rena|ren|re) VCSH_COMMAND=rename;;
434 ru) VCSH_COMMAND=run;;
435 statu|stat|sta|st) VCSH_COMMAND=status;;
436 upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
437 versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
438 which|whi|wh) VCSH_COMMAND=which;;
439 write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
442 if [ x"$VCSH_COMMAND" = x'clone' ]; then
443 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
445 [ -n "$3" ] && VCSH_REPO_NAME=$3 || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
446 [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
447 export VCSH_REPO_NAME
448 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
449 elif [ "$VCSH_COMMAND" = 'version' ]; then
450 echo "$SELF $VERSION"
453 elif [ x"$VCSH_COMMAND" = x'which' ]; then
454 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
455 [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
456 VCSH_COMMAND_PARAMETER=$2; export VCSH_COMMAND_PARAMETER
457 elif [ x"$VCSH_COMMAND" = x'delete' ] ||
458 [ x"$VCSH_COMMAND" = x'enter' ] ||
459 [ x"$VCSH_COMMAND" = x'init' ] ||
460 [ x"$VCSH_COMMAND" = x'list-tracked-by' ] ||
461 [ x"$VCSH_COMMAND" = x'rename' ] ||
462 [ x"$VCSH_COMMAND" = x'run' ] ||
463 [ x"$VCSH_COMMAND" = x'upgrade' ] ||
464 [ x"$VCSH_COMMAND" = x'write-gitignore' ]; then
465 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
466 [ x"$VCSH_COMMAND" = x'rename' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
467 [ x"$VCSH_COMMAND" = x'run' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
468 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
469 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
470 [ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
471 GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
472 [ x"$VCSH_COMMAND" = x'run' ] && shift 2
473 elif [ x"$VCSH_COMMAND" = x'commit' ] ||
474 [ x"$VCSH_COMMAND" = x'list' ] ||
475 [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
476 [ x"$VCSH_COMMAND" = x'list-untracked' ] ||
477 [ x"$VCSH_COMMAND" = x'pull' ] ||
478 [ x"$VCSH_COMMAND" = x'push' ]; then
480 elif [ x"$VCSH_COMMAND" = x'status' ]; then
481 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
482 elif [ -n "$2" ]; then
483 VCSH_COMMAND='run'; export VCSH_COMMAND
484 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
485 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
486 [ -d "$GIT_DIR" ] || { help; exit 1; }
489 elif [ -n "$VCSH_COMMAND" ]; then
490 VCSH_COMMAND='enter'; export VCSH_COMMAND
491 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
492 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
493 [ -d "$GIT_DIR" ] || { help; exit 1; }
495 # $1 is empty, or 'help'
499 # Did we receive a directory instead of a name?
500 # Mangle the input to fit normal operation.
501 if echo "$VCSH_REPO_NAME" | grep -q '/'; then
502 GIT_DIR=$VCSH_REPO_NAME; export GIT_DIR
503 VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git); export VCSH_REPO_NAME
508 if [ ! -d "$check_directory" ]; then
509 if [ -e "$check_directory" ]; then
510 fatal "'$check_directory' exists but is not a directory" 13
512 verbose "attempting to create '$check_directory'"
513 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
518 check_dir "$VCSH_REPO_D"
519 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
520 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
522 verbose "$VCSH_COMMAND begin"
523 VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
527 verbose "$VCSH_COMMAND end, exiting"
528 exit $VCSH_COMMAND_RETURN_CODE